﻿Imports System.Web.Http

Namespace GovDataAPI
	Public NotInheritable Class WebApiConfig
		Private Sub New()
		End Sub
		Public Shared Sub Register(ByVal config As HttpConfiguration)
			config.Routes.MapHttpRoute(name:= "DefaultApi", routeTemplate:= "api/{controller}/{id}", defaults:= New With {Key .id = RouteParameter.Optional})

			' Uncomment the following line of code to enable query support for actions with an IQueryable or IQueryable<T> return type.
			' To avoid processing unexpected or malicious queries, use the validation settings on QueryableAttribute to validate incoming queries.
			' For more information, visit http://go.microsoft.com/fwlink/?LinkId=279712.
			'config.EnableQuerySupport();

			' To disable tracing in your application, please comment out or remove the following line of code
			' For more information, refer to: http://www.asp.net/web-api
			config.EnableSystemDiagnosticsTracing()


			' ignores the json ref loop issues: http://blogs.msdn.com/b/hongyes/archive/2012/09/04/loop-reference-handling-in-serializer.aspx
			' http://stackoverflow.com/questions/15029576/samples-not-working-for-web-api-help-page-when-using-an-entity-framework-complex
			config.Formatters.JsonFormatter.SerializerSettings.ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Ignore
			config.Formatters.JsonFormatter.SerializerSettings.PreserveReferencesHandling = Newtonsoft.Json.PreserveReferencesHandling.Objects
		End Sub
	End Class
End Namespace
