Imports System.Web.Http
Imports System.Web.Mvc
Imports GovDataAPI.Areas.HelpPage.Models

Namespace GovDataAPI.Areas.HelpPage.Controllers
	''' <summary>
	''' The controller that will handle requests for the help page.
	''' </summary>
	Public Class HelpController
		Inherits Controller
		Public Sub New()
			Me.New(GlobalConfiguration.Configuration)
		End Sub

		Public Sub New(ByVal config As HttpConfiguration)
			Configuration = config
		End Sub

		Private privateConfiguration As HttpConfiguration
		Public Property Configuration() As HttpConfiguration
			Get
				Return privateConfiguration
			End Get
			Private Set(ByVal value As HttpConfiguration)
				privateConfiguration = value
			End Set
		End Property

		Public Function Index() As ActionResult
			Return View(Configuration.Services.GetApiExplorer().ApiDescriptions)
		End Function

		Public Function Api(ByVal apiId As String) As ActionResult
			If Not String.IsNullOrEmpty(apiId) Then
				Dim apiModel As HelpPageApiModel = Configuration.GetHelpPageApiModel(apiId)
				If apiModel IsNot Nothing Then
					Return View(apiModel)
				End If
			End If

			Return View("Error")
		End Function
	End Class
End Namespace