Imports System.Collections.ObjectModel
Imports System.Net.Http.Headers
Imports System.Web.Http.Description

Namespace GovDataAPI.Areas.HelpPage.Models
	''' <summary>
	''' The model that represents an API displayed on the help page.
	''' </summary>
	Public Class HelpPageApiModel
		''' <summary>
		''' Initializes a new instance of the <see cref="HelpPageApiModel"/> class.
		''' </summary>
		Public Sub New()
			SampleRequests = New Dictionary(Of MediaTypeHeaderValue, Object)()
			SampleResponses = New Dictionary(Of MediaTypeHeaderValue, Object)()
			ErrorMessages = New Collection(Of String)()
		End Sub

		''' <summary>
		''' Gets or sets the <see cref="ApiDescription"/> that describes the API.
		''' </summary>
		Public Property ApiDescription() As ApiDescription

		''' <summary>
		''' Gets the sample requests associated with the API.
		''' </summary>
		Private privateSampleRequests As IDictionary(Of MediaTypeHeaderValue, Object)
		Public Property SampleRequests() As IDictionary(Of MediaTypeHeaderValue, Object)
			Get
				Return privateSampleRequests
			End Get
			Private Set(ByVal value As IDictionary(Of MediaTypeHeaderValue, Object))
				privateSampleRequests = value
			End Set
		End Property

		''' <summary>
		''' Gets the sample responses associated with the API.
		''' </summary>
		Private privateSampleResponses As IDictionary(Of MediaTypeHeaderValue, Object)
		Public Property SampleResponses() As IDictionary(Of MediaTypeHeaderValue, Object)
			Get
				Return privateSampleResponses
			End Get
			Private Set(ByVal value As IDictionary(Of MediaTypeHeaderValue, Object))
				privateSampleResponses = value
			End Set
		End Property

		''' <summary>
		''' Gets the error messages associated with this model.
		''' </summary>
		Private privateErrorMessages As Collection(Of String)
		Public Property ErrorMessages() As Collection(Of String)
			Get
				Return privateErrorMessages
			End Get
			Private Set(ByVal value As Collection(Of String))
				privateErrorMessages = value
			End Set
		End Property
	End Class
End Namespace