Namespace GovDataAPI.Areas.HelpPage
	''' <summary>
	''' This represents an image sample on the help page. There's a display template named ImageSample associated with this class.
	''' </summary>
	Public Class ImageSample
		''' <summary>
		''' Initializes a new instance of the <see cref="ImageSample"/> class.
		''' </summary>
		''' <param name="src">The URL of an image.</param>
		Public Sub New(ByVal src As String)
			If src Is Nothing Then
				Throw New ArgumentNullException("src")
			End If
			Me.Src = src
		End Sub

		Private privateSrc As String
		Public Property Src() As String
			Get
				Return privateSrc
			End Get
			Private Set(ByVal value As String)
				privateSrc = value
			End Set
		End Property

		Public Overrides Overloads Function Equals(ByVal obj As Object) As Boolean
			Dim other As ImageSample = TryCast(obj, ImageSample)
			Return other IsNot Nothing AndAlso Src = other.Src
		End Function

		Public Overrides Function GetHashCode() As Integer
			Return Src.GetHashCode()
		End Function

		Public Overrides Function ToString() As String
			Return Src
		End Function
	End Class
End Namespace