Namespace GovDataAPI.Areas.HelpPage
	''' <summary>
	''' This represents an invalid sample on the help page. There's a display template named InvalidSample associated with this class.
	''' </summary>
	Public Class InvalidSample
		Public Sub New(ByVal errorMessage As String)
			If errorMessage Is Nothing Then
				Throw New ArgumentNullException("errorMessage")
			End If
			Me.ErrorMessage = errorMessage
		End Sub

		Private privateErrorMessage As String
		Public Property ErrorMessage() As String
			Get
				Return privateErrorMessage
			End Get
			Private Set(ByVal value As String)
				privateErrorMessage = value
			End Set
		End Property

		Public Overrides Overloads Function Equals(ByVal obj As Object) As Boolean
			Dim other As InvalidSample = TryCast(obj, InvalidSample)
			Return other IsNot Nothing AndAlso ErrorMessage = other.ErrorMessage
		End Function

		Public Overrides Function GetHashCode() As Integer
			Return ErrorMessage.GetHashCode()
		End Function

		Public Overrides Function ToString() As String
			Return ErrorMessage
		End Function
	End Class
End Namespace