Namespace GovDataAPI.Areas.HelpPage
	''' <summary>
	''' This represents a preformatted text sample on the help page. There's a display template named TextSample associated with this class.
	''' </summary>
	Public Class TextSample
		Public Sub New(ByVal text As String)
			If text Is Nothing Then
				Throw New ArgumentNullException("text")
			End If
			Me.Text = text
		End Sub

		Private privateText As String
		Public Property Text() As String
			Get
				Return privateText
			End Get
			Private Set(ByVal value As String)
				privateText = value
			End Set
		End Property

		Public Overrides Overloads Function Equals(ByVal obj As Object) As Boolean
			Dim other As TextSample = TryCast(obj, TextSample)
			Return other IsNot Nothing AndAlso Text = other.Text
		End Function

		Public Overrides Function GetHashCode() As Integer
			Return Text.GetHashCode()
		End Function

		Public Overrides Function ToString() As String
			Return Text
		End Function
	End Class
End Namespace