﻿Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Input

Namespace GovDataVisApp.Commands
	' http://www.geekchamp.com/articles/building-a-reusable-icommand-implementation-for-windows-phone-mango-mvvm-apps
	Public Class DelegateCommand
		Implements ICommand
'INSTANT VB NOTE: The variable canExecute was renamed since Visual Basic does not allow class members with the same name:
		Private canExecute_Renamed As Func(Of Object, Boolean)
		Private executeAction As Action(Of Object)

		Public Sub New(ByVal executeAction As Action(Of Object))
			Me.New(executeAction, Nothing)
		End Sub

		Public Sub New(ByVal executeAction As Action(Of Object), ByVal canExecute As Func(Of Object, Boolean))
			If executeAction Is Nothing Then
				Throw New ArgumentNullException("executeAction")
			End If

			Me.executeAction = executeAction
			Me.canExecute_Renamed = canExecute
		End Sub

		Public Function CanExecute(ByVal parameter As Object) As Boolean Implements ICommand.CanExecute
			Dim result As Boolean = True
			Dim canExecuteHandler As Func(Of Object, Boolean) = Me.canExecute_Renamed

			If canExecuteHandler IsNot Nothing Then
				result = canExecuteHandler(parameter)
			End If

			Return result
		End Function

		Public Event CanExecuteChanged As EventHandler Implements ICommand.CanExecuteChanged

		Public Sub Execute(ByVal parameter As Object) Implements ICommand.Execute
			Me.executeAction(parameter)
		End Sub

		Private Sub RaiseCanExecuteChanged()
			Dim handler As EventHandler = Me.CanExecuteChanged

			If handler IsNot Nothing Then
				handler(Me, New EventArgs())
			End If
		End Sub
	End Class
End Namespace
