﻿Imports Bing.Maps
Imports GovDataVisApp.Models
Imports GovDataVisApp.ViewModels
Imports System.IO
Imports System.Linq
Imports Windows.Devices.Geolocation
Imports Windows.Foundation
Imports Windows.Foundation.Collections
Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Controls
Imports Windows.UI.Xaml.Controls.Primitives
Imports Windows.UI.Xaml.Data
Imports Windows.UI.Xaml.Input
Imports Windows.UI.Xaml.Media
Imports Windows.UI.Xaml.Navigation

' The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

Namespace GovDataVisApp
	''' <summary>
	''' An empty page that can be used on its own or navigated to within a Frame.
	''' </summary>
	Public NotInheritable Partial Class MainPage
		Inherits Page
		Public Sub New()
			Me.DataContext = App.MapSearch

			Me.InitializeComponent()
		End Sub

		' recommendation from http://channel9.msdn.com/Shows/Inside+Windows+Phone/Practical-MVVM-For-Windows-Phone
		Private ReadOnly Property _viewModel() As MapSearchViewModel
			Get
				Return TryCast(Me.DataContext, MapSearchViewModel)
			End Get
		End Property

		''' <summary>
		''' Invoked when this page is about to be displayed in a Frame.
		''' </summary>
		''' <param name="e">Event data that describes how this page was reached.  The Parameter
		''' property is typically used to configure the page.</param>
		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
		End Sub

		Private Sub myMap_Tapped(ByVal sender As Object, ByVal e As TappedRoutedEventArgs)
			Dim result As MapSearchResult = Me.CurrentResult(TryCast(e.OriginalSource, FrameworkElement))
			' ensures we don't show the search box when a pin is tapped
			If result Is Nothing AndAlso (Not Me._viewModel.IsWorking) Then
				Dim p As Point = e.GetPosition(Me.myMap)
				Dim location As New Location()
				myMap.TryPixelToLocation(p, location)

				Me._viewModel.Query.Text = String.Empty
				Me._viewModel.Query.Radius = 20
				' set the lat lon values
				Me._viewModel.Query.Latitude = location.Latitude
				Me._viewModel.Query.Longitude = location.Longitude

				' show the item search window
				searchInput.HorizontalOffset = p.X
				searchInput.VerticalOffset = p.Y

				If itemDetails.IsOpen Then
					itemDetails.IsOpen = False
				End If
				If Not searchInput.IsOpen Then
					searchInput.IsOpen = True
				End If
			End If
		End Sub

		Private Sub pushpin_Clicked(ByVal sender As Object, ByVal e As PointerRoutedEventArgs)
			Dim p As Point = e.GetCurrentPoint(Me.myMap).Position
			Me._viewModel.SelectedResult = Me.CurrentResult(TryCast(e.OriginalSource, FrameworkElement))


			itemDetails.HorizontalOffset = p.X - 100
			itemDetails.VerticalOffset = p.Y - 160

			If searchInput.IsOpen Then
				searchInput.IsOpen = False
			End If
			If Not itemDetails.IsOpen Then
				itemDetails.IsOpen = True
			End If
		End Sub

		Private Function CurrentResult(ByVal element As FrameworkElement) As MapSearchResult
			If element Is Nothing Then
				Return Nothing
			End If
			Return TryCast((CType(element, FrameworkElement)).DataContext, MapSearchResult)
		End Function
	End Class
End Namespace
